
#include <stdlib.h>
#include <stdio.h>

int check(int combination[])
{
  int i;
  int cs = 0;

  for (i = 0; i < 6; i++)
  {
    cs = (cs + 13 * combination[i] + 4) % 31;
  };
  return (cs == 9);
};

int main(int argc, char **argv)
{
  int combination[6] = {0,0,0,0,0,0};
  int n = 0;
  int handle = 0;
  char c;
  int update = 1;

  printf("You stand before a closed safe with a handle and a button.\n");

  while (!check(combination))
  {
    if (update)
    {
      printf("You may:\nl) turn the handle to the left\n");
      printf("r) turn the handle to the right\nb) press the button\n> ");
      update = 0;
    };
    scanf("%c", &c);

    switch(c)
    {
      case '\n':
        break;

      case 'l':
        handle--;
        if (handle < 0)
          handle = 5;
        update = 1;
        break;

      case 'r':
        handle++;
        if (handle > 5)
          handle = 0;
        update = 1;
        break;

      case 'b':
        combination[n] = handle;
        n++;
        if (n > 6)
        {
          for (n = 6; n > 0; n--)
            combination[n] = 0;
        };
        update = 1;
        break;

      default:
        printf("Invalid command!\n");
        break;
    };
  };
  printf("The safe opens.\n");
};

